unit UInstallComp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TInstallComponent = class(TForm)
    btnHelp: TButton;
    btnCancel: TButton;
    btnOK: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    cbPackage: TComboBox;
    Edit2: TEdit;
    edUnitName: TEdit;
    Button4: TButton;
    Button5: TButton;
    Bevel2: TBevel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit3: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Button6: TButton;
    Button7: TButton;
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure LoadKnownPackages;
  public
    { Public declarations }
  end;

var
  InstallComponent: TInstallComponent;

implementation

uses Uconst;

{$R *.DFM}

procedure TInstallComponent.Button4Click(Sender: TObject);
begin
   OpenDialog1.Filter := 'Delphi Unit(*.pas)|*.pas'+
                         '|All Files (*.*)|*.*';
   OpenDialog1.Title:='Unit file name';
   if OpenDialog1.Execute then
      edUnitName.Text:= OpenDialog1.FileName;
end;

procedure TInstallComponent.Button5Click(Sender: TObject);
begin
   OpenDialog1.Filter := 'Delphi package source(*.dpk)|*.dpk'+
                         '|All Files (*.*)|*.*';
   OpenDialog1.Title:='Unit file name';
   if OpenDialog1.Execute then
      cbPackage.Text:= OpenDialog1.FileName;
end;

procedure TInstallComponent.LoadKnownPackages;
var
  PackageList:TStringList;
  I:Integer;
  PackageName, PackageDescrip:string;
begin
   PackageList:= TStringList.Create;
   IniFile.ReadSectionValues('KnownPackages',PackageList);
   cbPackage.Clear;
   for I:=0 to PackageList.Count - 1 do begin
      PackageName:= PackageList.Names[I];
      PackageDescrip:= PackageList.Values[PackageName];
      cbPackage.Items.Add(PackageName);
   end;
end;

procedure TInstallComponent.FormShow(Sender: TObject);
begin
   LoadKnownPackages;
end;


end.
